<?php

/**
 * inf_nota_credito actions.
 *
 * @package    cartera
 * @subpackage inf_nota_credito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_nota_creditoActions extends sfQuery {

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para listar el informe nota debito
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */

            //To_Char(Tab0.Fecha_Proceso_cre, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
            if (isset($request['fecha_ini']) && isset($request['fecha_fin'])) {
                $fecha_ini = $request['fecha_ini'];
                $fecha_fin = $request['fecha_fin'];

                $whereFecha = " Tab0.Fecha_Proceso_cre between to_date('" . $fecha_ini . "', 'YYYY-MM-DD') and to_date('" . $fecha_fin . "', 'YYYY-MM-DD') ";
            } else {
                $fecha_ini_anu = $request['fecha_ini_anu'];
                $fecha_fin_anu = $request['fecha_fin_anu'];

                $whereFecha = " Tab0.Fecha_anu_cre between to_date('" . $fecha_ini_anu . "', 'YYYY-MM-DD') and to_date('" . $fecha_fin_anu . "', 'YYYY-MM-DD') ";
            }


            /*
             * Se cambio filtro de estado para fecha_fin de anulacion - 20130905
             */
            if (isset($request['estado'])) {
                if ($request['estado'] == 'false') {
                    $estado = 0;
                    $whereEstado = " and (case when Tab0.fecha_anu_cre<=last_day(to_date('" . $fecha_fin_anu . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
                } else {
                    $estado = 1;
                    $whereEstado = " and (case when Tab0.fecha_anu_cre<=last_day(to_date('" . $fecha_fin . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
                }
            } else {
                $estado = 1;
                $whereEstado = " and (case when Tab0.fecha_anu_cre<=last_day(to_date('" . $fecha_fin . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
            }

            //punto venta
            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }

            /*
             * Variables opcionales
             */
            //tercero
            // if (isset($request['id_mae_ter'])) {
            //   $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            // } else {
            //   $whereTercero = ' ';
            //}
            //tipo debito
            if (isset($request['id_tipo_credito'])) {
                $whereTipoCredito = " AND tab0.id_tipo_credito = " . $request['id_tipo_credito'];
            } else {
                $whereTipoCredito = ' ';
            }


            if (isset($request['id_con_credito'])) {
                $whereConCredito = " AND tab0.id_con_credito = " . $request['id_con_credito'];
            } else {
                $whereConCredito = ' ';
            }


            if (isset($request['id_bn'])) {
                $whereBanco = " AND tab0.id_bn = " . $request['id_bn'];
            } else {
                $whereBanco = ' ';
            }


            if (isset($request['id_cb'])) {
                $whereCuenta = " AND tab0.id_cb = " . $request['id_cb'];
            } else {
                $whereCuenta = ' ';
            }

            if (isset($request['id_ts_td'])) {
                $whereTipoDocumento = " AND tab0.id_ts_td = " . $request['id_ts_td'];
            } else {
                $whereTipoDocumento = ' ';
            }
            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (

Select * From (


Select distinct

1 as Orden,
null as id_credito,
null as id_punto_venta,
null as id_tipo_credito,
null as sec_credito,
id_con_credito,
null as fecha_proceso_cre,
null as num_doc,
null as estado,
null as valor_bruto_credet,
null as valor_retenciones,
null as valor_abono,
null as fecha_anu_cre,
null as motivo_anu,
null as Sec_Debito,
null as Id_Tipo_Debito,
null as fecha_debito,
null as descripcion_tipcre,
null as Nitocc,
null as Razon_Soc,
-1 as Id_Mae_Ter,
null as desc_deb,
'NOTA CREDITO: ' || Desc_Corta_Concre  As Tercero

FROM(

select
*
FROM Ca_Credito_Vencimientos Tab0

Join Ca_Debito Tab1
On Tab1.Id_Debito = Tab0.Id_Debito

Join Ca_Tipo_Debito Tab2
on Tab2.Id_Tipo_Debito = Tab1.Id_Tipo_Debito

Join Interceros Ter
on Ter.Id_Mae_Ter = Tab1.Id_Mae_Ter

LEFT JOIN INTERCER_DU tab3 ON tab3.id_mae_ter = Tab1.id_mae_ter

LEFT JOIN INTERCER_DU_DIR tab4 ON tab4.ID_MT_UBI = tab3.ID_MT_UBI

LEFT JOIN USUARIO tab5 ON tab5.username = Tab0.Usuariolog

left join( 

select id_credito,sum(nvl(valor,0)) AS VALOR 
FROM ca_excedentes 
group by id_credito 
)Tab7 ON Tab7.id_credito = tab0.id_credito

Where
$whereFecha
$whereEstado $whereTipoCredito $wherePuntoVenta $whereConCredito $whereBanco $whereCuenta $whereTipoDocumento 

)


union

Select

3 as Orden,
null as id_credito,
null as id_punto_venta,
null as id_tipo_credito,
null as sec_credito,
id_con_credito,
null as fecha_proceso_cre,
null as num_doc,
null as estado,
null as valor_bruto_credet,
null as valor_retenciones,
sum(valor_abono)+sum(diferencia_cambio)+sum(excedente) as valor_abono, 
null as fecha_anu_cre,
null as motivo_anu,
null as Sec_Debito,
null as Id_Tipo_Debito,
null as  fecha_debito,
null as descripcion_tipcre,
null as Nitocc,
null as Razon_Soc,
-1 as d_mae_ter,
null as desc_deb,
'TOTAL NOTA CREDITO: ' || Desc_Corta_Concre  As Tercero

FROM(

select tab0.*,
   case when Tab0.id_credito_detalle = (select min(cred.id_credito_detalle) from ca_credito_detalle cred 
       where cred.id_credito = tab0.id_credito) then nvl(tab7.valor,0) else 0 end AS EXCEDENTE 

From Ca_Credito_Vencimientos tab0

Join Ca_Debito Tab1
On Tab1.Id_Debito = Tab0.Id_Debito

Join Ca_Tipo_Debito Tab2
on Tab2.Id_Tipo_Debito = Tab1.Id_Tipo_Debito

Join Interceros Ter
on Ter.Id_Mae_Ter = Tab1.Id_Mae_Ter

LEFT JOIN INTERCER_DU tab3 ON tab3.id_mae_ter = Tab1.id_mae_ter

LEFT JOIN INTERCER_DU_DIR tab4 ON tab4.ID_MT_UBI = tab3.ID_MT_UBI

LEFT JOIN USUARIO tab5 ON tab5.username = Tab0.Usuariolog

left join( 
select id_credito,sum(nvl(valor,0)) AS VALOR 
FROM ca_excedentes 
group by id_credito 
)Tab7 ON Tab7.id_credito = tab0.id_credito 

Where
$whereFecha
$whereEstado $whereTipoCredito $wherePuntoVenta $whereConCredito $whereBanco $whereCuenta $whereTipoDocumento 

)

Group By
id_con_credito,
Desc_Corta_Concre

Union

Select

2 as Orden,
Tab0.id_credito,
Tab0.id_punto_venta,
Tab0.id_tipo_credito,
Tab0.sec_credito,
Tab0.id_con_credito,
Tab0.fecha_proceso_cre,
Tab0.num_doc,
Tab0.estado_cre as estado,
Tab0.valor_bruto_credet,
Tab0.valor_retenciones,
Tab0.valor_abono+Tab0.diferencia_cambio+(
   case when Tab0.id_credito_detalle = (select min(cred.id_credito_detalle) from ca_credito_detalle cred 
       where cred.id_credito = tab0.id_credito) then nvl(tab7.valor,0) else 0 end ) as valor_abono,
Tab0.fecha_anu_cre,
Tab0.motivo_anu,
Tab1.Sec_Debito,
Tab1.Id_Tipo_Debito,
Tab1.fecha_proceso as fecha_debito,
tab0.descripcion_tipcre,
Ter.Num_Doc As Nitocc,
Ter.Razon_Soc,
tab1.id_mae_ter,
tab2.desc_corta as desc_deb,
Ter.Num_Doc || ' - ' || Ter.Razon_Soc AS Tercero 



From Ca_Credito_Vencimientos tab0

Join Ca_Debito Tab1
On Tab1.Id_Debito = Tab0.Id_Debito

Join Ca_Tipo_Debito Tab2
on Tab2.Id_Tipo_Debito = Tab1.Id_Tipo_Debito

Join Interceros Ter
on Ter.Id_Mae_Ter = Tab1.Id_Mae_Ter

LEFT JOIN INTERCER_DU tab3 ON tab3.id_mae_ter = Tab1.id_mae_ter

LEFT JOIN INTERCER_DU_DIR tab4 ON tab4.ID_MT_UBI = tab3.ID_MT_UBI

LEFT JOIN USUARIO tab5 ON tab5.username = Tab0.Usuariolog

left join( 
select id_credito,sum(nvl(valor,0)) AS VALOR 
FROM ca_excedentes 
group by id_credito 
)Tab7 ON Tab7.id_credito = tab0.id_credito 

Where
$whereFecha
$whereEstado $whereTipoCredito $wherePuntoVenta $whereConCredito $whereBanco $whereCuenta $whereTipoDocumento 

)

Order By
id_con_credito,
Orden,
Sec_Credito
)

EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (


Select * From (


Select distinct

1 as Orden,
null as id_credito,
null as id_punto_venta,
null as id_tipo_credito,
null as sec_credito,
id_con_credito,
null as fecha_proceso_cre,
null as num_doc,
null as estado,
null as valor_bruto_credet,
null as valor_retenciones,
null as valor_abono,
null as fecha_anu_cre,
null as motivo_anu,
null as Sec_Debito,
null as Id_Tipo_Debito,
null as fecha_debito,
null as descripcion_tipcre,
null as Nitocc,
null as Razon_Soc,
-1 as Id_Mae_Ter,
null as desc_deb,
'NOTA CREDITO: ' || Desc_Corta_Concre  As Tercero

FROM(

select
*
FROM Ca_Credito_Vencimientos Tab0

Join Ca_Debito Tab1
On Tab1.Id_Debito = Tab0.Id_Debito

Join Ca_Tipo_Debito Tab2
on Tab2.Id_Tipo_Debito = Tab1.Id_Tipo_Debito

Join Interceros Ter
on Ter.Id_Mae_Ter = Tab1.Id_Mae_Ter

LEFT JOIN INTERCER_DU tab3 ON tab3.id_mae_ter = Tab1.id_mae_ter

LEFT JOIN INTERCER_DU_DIR tab4 ON tab4.ID_MT_UBI = tab3.ID_MT_UBI

LEFT JOIN USUARIO tab5 ON tab5.username = Tab0.Usuariolog

left join(
select id_credito,sum(nvl(valor,0)) AS VALOR 
FROM ca_excedentes 
group by id_credito 
)Tab7 ON Tab7.id_credito = tab0.id_credito

Where
$whereFecha
$whereEstado $whereTipoCredito $wherePuntoVenta $whereConCredito $whereBanco $whereCuenta $whereTipoDocumento 

)


union

Select

3 as Orden,
null as id_credito,
null as id_punto_venta,
null as id_tipo_credito,
null as sec_credito,
id_con_credito,
null as fecha_proceso_cre,
null as num_doc,
null as estado,
null as valor_bruto_credet,
null as valor_retenciones,
sum(NVL(valor_abono,0))+sum(NVL(diferencia_cambio,0))+sum(NVL(excedente,0)) as valor_abono, 
null as fecha_anu_cre,
null as motivo_anu,
null as Sec_Debito,
null as Id_Tipo_Debito,
null as  fecha_debito,
null as descripcion_tipcre,
null as Nitocc,
null as Razon_Soc,
-1 as d_mae_ter,
null as desc_deb,
'TOTAL NOTA CREDITO: ' || Desc_Corta_Concre  As Tercero

FROM(

select tab0.*,
   case when Tab0.id_credito_detalle = (select min(cred.id_credito_detalle) from ca_credito_detalle cred 
       where cred.id_credito = tab0.id_credito) then nvl(tab7.valor,0) else 0 end AS EXCEDENTE 

From Ca_Credito_Vencimientos tab0

Join Ca_Debito Tab1
On Tab1.Id_Debito = Tab0.Id_Debito

Join Ca_Tipo_Debito Tab2
on Tab2.Id_Tipo_Debito = Tab1.Id_Tipo_Debito

Join Interceros Ter
on Ter.Id_Mae_Ter = Tab1.Id_Mae_Ter

LEFT JOIN INTERCER_DU tab3 ON tab3.id_mae_ter = Tab1.id_mae_ter

LEFT JOIN INTERCER_DU_DIR tab4 ON tab4.ID_MT_UBI = tab3.ID_MT_UBI

LEFT JOIN USUARIO tab5 ON tab5.username = Tab0.Usuariolog

left join( 
select id_credito,sum(nvl(valor,0)) AS VALOR 
FROM ca_excedentes 
group by id_credito 
)Tab7 ON Tab7.id_credito = tab0.id_credito 

Where
$whereFecha
$whereEstado $whereTipoCredito $wherePuntoVenta $whereConCredito $whereBanco $whereCuenta $whereTipoDocumento 

)

Group By
id_con_credito,
Desc_Corta_Concre

Union

Select

2 as Orden,
Tab0.id_credito,
Tab0.id_punto_venta,
Tab0.id_tipo_credito,
Tab0.sec_credito,
Tab0.id_con_credito,
Tab0.fecha_proceso_cre,
Tab0.num_doc,
Tab0.estado_cre as estado,
NVL(Tab0.valor_abono,0)+NVL(Tab0.diferencia_cambio,0)+(
   case when Tab0.id_credito_detalle = (select min(cred.id_credito_detalle) from ca_credito_detalle cred 
       where cred.id_credito = tab0.id_credito) then nvl(tab7.valor,0) else 0 end ) as valor_bruto_credet,
Tab0.valor_retenciones,
Tab0.valor_abono+Tab0.diferencia_cambio+(
   case when Tab0.id_credito_detalle = (select min(cred.id_credito_detalle) from ca_credito_detalle cred 
       where cred.id_credito = tab0.id_credito) then nvl(tab7.valor,0) else 0 end ) as valor_abono,
Tab0.fecha_anu_cre,
Tab0.motivo_anu,
Tab1.Sec_Debito,
Tab1.Id_Tipo_Debito,
Tab1.fecha_proceso as fecha_debito,
tab0.descripcion_tipcre,
Ter.Num_Doc As Nitocc,
Ter.Razon_Soc,
tab1.id_mae_ter,
tab2.desc_corta as desc_deb,
Ter.Num_Doc || ' - ' || Ter.Razon_Soc AS Tercero 



From Ca_Credito_Vencimientos tab0

Join Ca_Debito Tab1
On Tab1.Id_Debito = Tab0.Id_Debito

Join Ca_Tipo_Debito Tab2
on Tab2.Id_Tipo_Debito = Tab1.Id_Tipo_Debito

Join Interceros_v Ter
on Ter.Id_Mae_Ter = Tab1.Id_Mae_Ter

LEFT JOIN INTERCER_DU tab3 ON tab3.id_mae_ter = Tab1.id_mae_ter

LEFT JOIN INTERCER_DU_DIR tab4 ON tab4.ID_MT_UBI = tab3.ID_MT_UBI

LEFT JOIN USUARIO tab5 ON tab5.username = Tab0.Usuariolog

left join( 
select id_credito,sum(nvl(valor,0)) AS VALOR 
FROM ca_excedentes 
group by id_credito 
)Tab7 ON Tab7.id_credito = tab0.id_credito 

Where
$whereFecha
$whereEstado $whereTipoCredito $wherePuntoVenta $whereConCredito $whereBanco $whereCuenta $whereTipoDocumento 

)

Order By
id_con_credito,
Orden,
Sec_Credito
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $this->startRow + count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar el informe nota debito
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */

            //To_Char(Tab0.Fecha_Proceso_cre, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
            if (isset($request['fecha_ini']) && isset($request['fecha_fin'])) {
                $fecha_ini = $request['fecha_ini'];
                $fecha_fin = $request['fecha_fin'];

                $whereFecha = " Tab0.Fecha_Proceso_cre between to_date('" . $fecha_ini . "', 'YYYY-MM-DD') and to_date('" . $fecha_fin . "', 'YYYY-MM-DD') ";
            } else {
                $fecha_ini_anu = $request['fecha_ini_anu'];
                $fecha_fin_anu = $request['fecha_fin_anu'];

                $whereFecha = " Tab0.Fecha_anu_cre between to_date('" . $fecha_ini_anu . "', 'YYYY-MM-DD') and to_date('" . $fecha_fin_anu . "', 'YYYY-MM-DD') ";
            }


            /*
             * Se cambio filtro de estado para fecha_fin de anulacion - 20130905
             */
            if (isset($request['estado'])) {
                if ($request['estado'] == 'false') {
                    $estado = 0;
                    $whereEstado = " and (case when Tab0.fecha_anu_cre<=last_day(to_date('" . $fecha_fin_anu . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
                } else {
                    $estado = 1;
                    $whereEstado = " and (case when Tab0.fecha_anu_cre<=last_day(to_date('" . $fecha_fin . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
                }
            } else {
                $estado = 1;
                $whereEstado = " and (case when Tab0.fecha_anu_cre<=last_day(to_date('" . $fecha_fin . "', 'YYYY-MM-DD')) then 0 else 1 END  = " . $estado . ") ";
            }

            //punto venta
            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }

            /*
             * Variables opcionales
             */
            if (isset($request['id_tipo_credito'])) {
                $whereTipoCredito = " AND tab0.id_tipo_credito = " . $request['id_tipo_credito'];
            } else {
                $whereTipoCredito = ' ';
            }

            if (isset($request['id_con_credito'])) {
                $whereConCredito = " AND tab0.id_con_credito = " . $request['id_con_credito'];
            } else {
                $whereConCredito = ' ';
            }


            if (isset($request['id_bn'])) {
                $whereBanco = " AND tab0.id_bn = " . $request['id_bn'];
            } else {
                $whereBanco = ' ';
            }


            if (isset($request['id_cb'])) {
                $whereCuenta = " AND tab0.id_cb = " . $request['id_cb'];
            } else {
                $whereCuenta = ' ';
            }

            if (isset($request['id_ts_td'])) {
                $whereTipoDocumento = " AND tab0.id_ts_td = " . $request['id_ts_td'];
            } else {
                $whereTipoDocumento = ' ';
            }


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

   count(*) as sec_credito,
   'TOTALES NOTAS CREDITO' as razon_soc,

SUM(NVL(valor_abono,0))+SUM(NVL(diferencia_cambio,0))+SUM(NVL(excedente,0)) as valor_bruto_credet, 
SUM(NVL(valor_retenciones,0)) as valor_retenciones, 
SUM(NVL(valor_abono,0))+SUM(NVL(diferencia_cambio,0))+SUM(NVL(excedente,0)) as valor_abono

FROM (

Select

2 as Orden,
Tab0.id_credito,
Tab0.id_punto_venta,
Tab0.id_tipo_credito,
Tab0.sec_credito,
Tab0.id_con_credito,
Tab0.fecha_proceso_cre,
Tab0.num_doc,
Tab0.estado_cre,
Tab0.valor_bruto_credet,
Tab0.valor_retenciones,
Tab0.valor_abono,
Tab0.diferencia_cambio,
Tab0.fecha_anu_cre,
Tab0.motivo_anu,
Tab1.Sec_Debito,
Tab1.Id_Tipo_Debito,
Tab1.fecha_proceso as fecha_debito,
tab0.descripcion_tipcre,
Ter.Num_Doc As Nitocc,
Ter.Razon_Soc,
tab1.id_mae_ter,
tab2.desc_corta as desc_deb,
Ter.Num_Doc || ' - ' || Ter.Razon_Soc AS Tercero,
   case when Tab0.id_credito_detalle = (select min(cred.id_credito_detalle) from ca_credito_detalle cred 
       where cred.id_credito = tab0.id_credito) then nvl(tab7.valor,0) else 0 end AS EXCEDENTE 


From Ca_Credito_Vencimientos tab0

Join Ca_Debito Tab1
On Tab1.Id_Debito = Tab0.Id_Debito

Join Ca_Tipo_Debito Tab2
on Tab2.Id_Tipo_Debito = Tab1.Id_Tipo_Debito

Join Interceros_v Ter
on Ter.Id_Mae_Ter = Tab1.Id_Mae_Ter

LEFT JOIN INTERCER_DU tab3 ON tab3.id_mae_ter = Tab1.id_mae_ter

LEFT JOIN INTERCER_DU_DIR tab4 ON tab4.ID_MT_UBI = tab3.ID_MT_UBI

LEFT JOIN USUARIO tab5 ON tab5.username = Tab0.Usuariolog

left join( 
select id_credito,sum(nvl(valor,0)) AS VALOR 
FROM ca_excedentes 
group by id_credito 
)Tab7 ON Tab7.id_credito = tab0.id_credito 

Where
$whereFecha
$whereEstado $whereTipoCredito $wherePuntoVenta $whereConCredito $whereBanco $whereCuenta $whereTipoDocumento 


Order By
Tab0.Id_Con_Credito,
Tab0.Sec_Credito,
Tab0.Id_Tipo_Credito

)

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
